#ifndef __NAJITOOL__LIBNAJI_H__NAJI__
#define __NAJITOOL__LIBNAJI_H__NAJI__

/* --------- */
/* libnaji.h */
/* --------- */

/* libnaji header file */

/* this  .h  file is a part */
/* of libnaji version 0.3.0 */

/* libnaji is based on   */
/* the original najitool */

/* both najitool and libnaji */
/* are public domain and are */
/* made by the same author   */
/* please read license.txt   */

/* made by NECDET COKYAZICI  */

#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* the random number initilizer macro */
/* using this before using the rndrange() */
/* macros is highly recommended because it */
/* makes rndrange produce a lot better */
/* random numbers, you only need to use */
/* it once.  */
#define rndinit() srand(time(NULL))

#define rndrange(start, end)  ( (rand() % (end) ) + (start) ) )


#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

#define UCHAR unsigned char
#define UINT unsigned int
#define ULONG unsigned long

#define SCHAR signed char
#define SINT signed int
#define SLONG signed long

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

typedef signed char schar;
typedef signed int sint;
typedef signed long slong;

#define square_root(a) ((a) * (a))
#define naji_max(a,b) ( ( (a) > (b) ) ? (a):(b) )
#define naji_min(a,b) ( ( (a) < (b) ) ? (a):(b) )

#ifndef PI
#define PI 3.14159265358979323846
#endif

#define newint(amount)  ( (int*) ( malloc(amount) ) )
#define newchar(amount) ( (char*) ( malloc(amount) ) ) 
#define newlong(amount) ( (long*) ( malloc(amount) ) )

#define exitnull(item) \
if ( ( (item) == NULL ) ) \
{\
fprintf(stderr, "\n\nNULL pointer error\n\n"); exit(8);\
}



#define loop while(1)
#define endloop break

/* my version of the FALSE, TRUE defines */
/* to avoid clashes with other libraries and programs */

#define NAJI_FALSE 0
#define NAJI_TRUE  1

extern FILE* naji_input;
extern FILE* naji_input2;
extern FILE* naji_output;
extern FILE* naji_output2;
extern FILE* naji_bmp_out;
extern FILE* naji_edit;

void naji_unicode_html_header(int n);
void naji_unicode_html_end(void);
void naji_del_gen_unicode_html_pages(void);
void naji_gen_unicode_html_pages(void);

void kitten_stdin(void);
void cat_text_stdin(void);
void cat_text_faster_stdin(void);
void cat_text_fastest_stdin(void);


long naji_filesize(FILE *file);
long najin2size(void);
long najinsize(void);
long najout2size(void);
long najoutsize(void);
long najedsize(void);

void najin(char *namein);
void najin2(char *namein2);
void najout(char *nameout);
void najout2(char *nameout2);
void najed(char *named);

void najinclose(void);
void najin2close(void);
void najoutclose(void);
void najout2close(void);
void najedclose(void);

uchar uc_rand_range(uchar start, uchar end);
uint ui_rand_range(uint start, uint end);
ulong ul_rand_range (ulong start, ulong end);

void addim(int max_times);

void _8bit256(char *nameout, unsigned long rep);
void _bigascii(char *string, FILE *stream);

void arab2eng(char *namein, char *nameout);
void eng2arab(char *namein, char *nameout);
int naji_a2e(int a);
int naji_e2a(int a);
int naji_e2a_unicode(int a);
void e2ahtml(char *namein, char *nameout);

void bigascif(char *string, char *nameout);
void bigascii(char *string);

void bin2c(char *namein, char *nameout, char *array_name);
void bin2hexi(char *namein, char *nameout);
void bin2text(char *namein, char *nameout);

void cat_text(char *namein);
void cat_text_faster(char *namein);
void cat_text_fastest(char *namein);

void ccompare(char *namein, char *namein2);
void charfile(char *nameout, unsigned long int size, int c);
void compare(char *namein, char *namein2);
void compfile(char *namein, char *namein2, int cont_on_diff);
void copyfile(char *namein, char *nameout);
void dos2unix(char *namein, char *nameout);
void errtext(void);
void hmakerf(char *namein, char *nameout);
void filechop(long copytil, char *namein, char *nameout, char *nameout2);
void flipcopy(char *namein, char *nameout);
void freverse(char *namein, char *nameout);
void revlines(char *namein, char *nameout);
void hexicat(char *namein);
void revcat(char *namein);
void hexierr(void);
void hmaker(char *namein);
void htmlfast(char *namein, char *nameout);
void kiterr(void);
void kitten(char *namein);
void mergline(char *namein, char *namein2, char *nameout, char *beforeline, char *afterline);
void putlines(char *namein, char *nameout, char *beforeline, char *afterline);
void naji_addim(unsigned long start, unsigned long end, unsigned long addby);
void naji_ascii(char *string, int i, int a, FILE *stream);

void coffset(char *namein, long startpos, long endpos);
void copyoffs(char *namein, long startpos, long endpos, char *nameout);



void naji_bmpheader(void);
void bmpout(char *nameout);
void bmpoutclose(void);
void naji_bmp(void);

void naji_genlic();
void naji_license(void);

void onlycat(char *namein, char *toshow);
void onlychar(char *namein, char *nameout, char *toshow);
void rand_init(void);
void repcat(char *namein, unsigned int repeat);
void repcatpp(char *namein, unsigned int start);
void repchar(char *namein, char *nameout, unsigned int repeat);
void repcharp(char *namein, char *nameout, unsigned int start);
void reperr(unsigned int repeat);
void rndbfile(char *nameout, unsigned long int size);
void rndtfile(char *nameout, unsigned long int size);
void show_16_bit_bin(int num);
void skipcat(char *namein, char *toskip);
void skipchar(char *namein, char *nameout, char *toskip);
void skiperr(char *toskip);
void strfile(char *nameout, unsigned long int howmany, char *string);
void tabspace(int spaces, char *namein, char *nameout);
void txt2html(char *namein, char *nameout);
void unix2dos(char *namein, char *nameout);
int wrdcount(char *namein);
int swrdcoun(const char *string);
void sreverse(char *str);
void sflpcase(char *str);
void stoupper(char *str);
void stolower(char *str);
void safegets(char *buf, int size);
void naji_calc(void);

void sortfirst(char *namein, char *nameout);
void sortlast(char *namein, char *nameout);
void sortlenl(char *namein, char *nameout);
void rcharvar(char *str);
void lcharvar(char *str);
void asctable(void);
void najcrypt(void);
void engnum(void);
void turnum(void);

void qcrypt(char *namein, char *nameout);
void fillfile(char *named, char c);
void rndffill(char *named);
int zerokill(char *name);
int randkill(char *name);
void najisum(char *namein);
void rndbsout(unsigned long int size);
void rndtsout(unsigned long int size);



/* the database stuff I wrote */
void add_entry(char *entry);
void naji_database(void);

void add_entry_html(char *entry);
void add_entry_html_link(char *entry);
void add_entry_html_email(char *entry);
void naji_html_database(void);

/* WARNING: be very careful with this */
/* function, it makes a lot of files  */

/* you give it the size in bytes of every  */
/* possible byte combination that you want */
void allfiles(int size);

#endif /* __NAJITOOL__LIBNAJI_H__NAJI__ */

